# Macros from rpm-4.0.4
%define def_with() %{expand:%%{!?_with_%{1}: %%{!?_without_%{1}: %%global _with_%{1} --with-%{1}}}}
%define def_without() %{expand:%%{!?_with_%{1}: %%{!?_without_%{1}: %%global _without_%{1} --without-%{1}}}}
%define if_with() %if %{expand:%%{?_with_%{1}:1}%%{!?_with_%{1}:0}}

# Define what kernel packages to be built.
%def_with UP
%def_with UP_SECURE
%def_without UP_RSBAC
%def_with SMP
%def_with SMP_SECURE
%def_without SMP_RSBAC
%def_without BOOT
%def_without CUSTOM

# Define what kernel-related packages to be built.
%def_with HEADERS
%def_with SOURCE
%def_with DOCS

# Other kernel parameters and components.
%def_with ALSA
%def_with PCMCIA
%def_with IBCS
%def_without COMPRESS_MODULES

# Define what ALSA modules to be built.
%{!?ALSA_MODULES:%global ALSA_MODULES all}

# Custom kernel parameters.
%{!?CUSTOM:%global CUSTOM custom}

%define sublevel 25
%define kversion 2.2.%sublevel

Name: kernel22
Version: %kversion
%define alt_release alt2.M22
%define pre_release %nil
Release: %alt_release%pre_release

%define srcversion 2.2.25
#%%define prever 2.2.24
%define andreaver 2.2.21pre2aa2
%define alsaver 0.5.12a
%define bttver 0.7.92
%define cryptover 2.2.18-3
%define emuver 20011111
%define e2cver 0.4.38
%define ibcsver 2.1-981105
%define ipsecver 1.99
%define ipvsver 1.0.6
%define lmver 2.6.4
%define nwver 0803
%define owver 2.2.25-ow2
%define rsbacver 1.1.2
%define rsbacbugfixver 0
%define pcmciaver 3.2.1
%define reiserfsver 3.5.33
%define vlanver 1.4
%define KVERREL %kversion-%release

%define kernel_prereq mkinitrd >= 2.7.1-alt4, modutils >= 2.4.17, /sbin/installkernel, /usr/sbin/rdev

Summary: The Linux kernel - core of the GNU/Linux operating system
License: GPL
Group: System/Kernel and hardware

ExclusiveArch: %ix86
ExclusiveOS: Linux

###############
### SOURCES ###
###############

Source0 : ftp://ftp.kernel.org/pub/linux/kernel/v2.2/linux-%srcversion.tar.bz2
Source1 : ftp://projects.sourceforge.net/pub/pcmcia-cs/pcmcia-cs-%pcmciaver.tar.bz2
Source2 : ftp://tsx-11.mit.edu/pub/linux/BETA/ibcs2/ibcs-%ibcsver.tar.bz2
Source3 : ftp://ftp.xs4all.nl/pub/crypto/freeswan/freeswan-%ipsecver.tar.bz2
Source5 : ftp://ftp.alsa-project.org/pub/driver/alsa-driver-%alsaver.tar.bz2
Source6 : ftp://opensource.creative.com/pub/snapshots/emu10k1-%emuver.tar.bz2
Source7 : http://www.openwall.com/linux/linux-%owver.tar.bz2
Source8 : http://www2.lm-sensors.nu/~lm78/archive/i2c-%lmver.tar.bz2
Source9 : http://www2.lm-sensors.nu/~lm78/archive/lm_sensors-%lmver.tar.bz2
Source10: http://bytesex.org/bttv/bttv-%bttver.tar.bz2
Source11: http://scry.wanfear.com/~greear/vlan/vlan.%vlanver.tar.bz2
# Patches by Andrea Arcangeli <andrea@suse.de>:
# ftp://ftp.kernel.org/pub/linux/kernel/people/andrea/kernels/v2.2/%andreaver/
Source12: linux-kernel-people-andrea-kernels-v2.2-%andreaver.tar.bz2
# Driver for Granch SBNI12 Leased line modems.
Source13: http://www.granch.ru/filez/sbni501.tar.bz2
# Rule Set Based Access Control (RSBAC) for Linux: http://www.rsbac.org/code/index.htm
Source14: rsbac-v%rsbacver.tar.bz2
# NetWare filesystem: http://www.timpanogas.com/downloads.html
Source15: ftp://207.109.151.240/nwfs20/nwfs%nwver.tar.bz2

Source20: README.kernel-sources
Source21: supermount.README.txt
Source23: rhkmvtag.c
Source24: kernel-2.2-BuildASM.sh
Source25: linux_logo.h.bz2

# The DEFAULT config for all kernels.
Source100: kernel-%kversion-i586-up.config

Source101: kernel-%kversion-i586-up-secure.config
Source102: kernel-%kversion-i586-up-rsbac.config
Source103: kernel-%kversion-i586-smp.config
Source104: kernel-%kversion-i586-smp-secure.config
Source105: kernel-%kversion-i586-smp-rsbac.config

Source110: kernel-%kversion-i686-up.config
Source111: kernel-%kversion-i686-up-secure.config
Source112: kernel-%kversion-i686-up-rsbac.config
Source113: kernel-%kversion-i686-smp.config
Source114: kernel-%kversion-i686-smp-secure.config
Source115: kernel-%kversion-i686-smp-rsbac.config

Source120: kernel-%kversion-k6-up.config
Source121: kernel-%kversion-k6-up-secure.config
Source122: kernel-%kversion-k6-up-rsbac.config

#Source130: kernel-%kversion-athlon-up.config
#Source131: kernel-%kversion-athlon-up-secure.config
#Source132: kernel-%kversion-athlon-smp.config
#Source133: kernel-%kversion-athlon-smp-secure.config

# The BOOT config.
Source200: kernel-%kversion-i386-boot.config

# Custom kernel configation.
%if_with CUSTOM
Source300: kernel-%kversion-%_arch-%CUSTOM.config
%endif #CUSTOM

###############
### PATCHES ###
###############

###
# Kernel version updates and -ac patches.
# 0..99 #
###

%{?prever:Patch1: ftp://ftp.kernel.org/pub/linux/kernel/v2.2/testing/patch-%prever.bz2}

# Fix for 2.2.20-pre9.
Patch2: pre-patch-2.2.20-9-drivers-isdn-eicon-lincfg.patch

# Fix for 2.2.21-pre4.
Patch3: linux-2.2.21-pre4-shrink_dcache_memory.patch

# Fix for 2.2.24-pre1.
Patch4: linux-2.2.24-pre1-skb_realloc_headroom.patch

Patch11: kernel-andrea-define-missing-syscalls.patch
Patch12: kernel-andrea-define-missing-types.patch

# Apply patch for Openwall patch ((i.e. update patch to current kernel, if required).
Patch21: linux-2.2.25-alt-%owver.patch

###
# Vendor patches
###

# ReiserFS.
Patch100: ftp://ftp.namesys.com/pub/reiserfs-for-2.2/linux-2.2.19-reiserfs-%reiserfsver.patch.bz2

# Fix LFS support in ReiserFS.
Patch101: linux-2.2.19-reiserfs-lfs.patch

# reiserfs has a slightly longer tq_scheduler function to do the slow
# part of the end_io handler. Some kernel subsystems enter the
# scheduler inside __cli() and it does no good to execute the reiserfs
# task queue function with interrupts off (causing the stuck on TLB
# IPI wait messages)
Patch102: linux-2.2.18-reiserfs-sti.patch

# Reformat the banners show.
Patch103: linux-2.2.18-reiserfs-format-banner.patch

# IPSEC: add config generated with make patches from the freeswan sources.
Patch105: linux-2.2.18-ipsec-config-1.8.patch

# s|DEBUG_IPSEC|CONFIG_DEBUG_IPSEC|; to be in the Configure.
Patch106: linux-2.2.18-ipsec-config-debug.patch

# IDE driver: ftp://ftp.kernel.org/pub/linux/kernel/people/hedrick/ide-2.2.19/
Patch110: ide.2.2.19.05042001-alt-2.2.21.patch.bz2

# Adapter RAID controller support (RedHat).
Patch111: linux-2.2.18-aacraid-1.0.3.patch.bz2
Patch112: linux-2.2.16-aacraid-1.0.4.patch
Patch113: linux-2.2.16-aacraid-1.0.5.patch
Patch114: linux-2.2.18-aacraid-1.0.6.patch
Patch115: linux-2.2.18-aacraid-1.0.6-path.patch
Patch116: linux-2.2.18-aacraid-1.0.7.patch
Patch117: linux-2.2.18-aacraid-1.0.7.PERCID.patch

# IBCS config to build it.
Patch120: linux-2.2.16-ibcs-config.patch

# Add locking to ibcs.
Patch121: linux-2.2.18-ibcs-locking.patch

# Make IBCS lfs compatible (Andrea Arcangeli <andrea@suse.de>)
Patch122: linux-2.2.18-ibcs-2.1-981105-LFS.patch

# IBCS kill_fasync patch.
Patch123: linux-2.2.18-ibcs_kill_fasync.patch

# Fix strlen_user usage in IBCS.
Patch124: linux-2.2.19pre16-ibcs-strlen_user.patch

# Fix PTRACED checks in IBCS.
Patch125: linux-2.2.20pre9-ibcs-pt_ptraced.patch

# IPVS: http://www.linuxvirtualserver.org
Patch126: linux-2.2.19-ipvs-1.0.6.patch.bz2

# Allow VPN with Masquerading: http://www.impsec.org/linux/masquerade/ip_masq_vpn.html
Patch127: linux-2.2.19-ip_masq_vpn.patch.bz2

# CIPE - encrypted IP over UDP tunneling.
Patch128: linux-2.2.18-cipe.patch.bz2

# Add sysrq on serial.
Patch130: linux-2.2.18-serial-sysrq.patch

# Add support for EtherExpressPro/1000 support.
Patch131: linux-2.2.18-e1000.patch.bz2

# Add 8280 eepro100 familly support.
Patch132: linux-2.2.18-eepro100-add-82820-card.patch

# Make eepro100 use io.
Patch133: linux-2.2.18-eepro-useio.patch

# Intel driver of EtherExpressPro/100 support.
Patch134: linux-2.2.18-e100.patch.bz2

# Fix compile of e100 with 2.2.18.
Patch135: linux-2.2.18-ee100-fixcompile.patch

# Add support for Qlogic QLA 1280/12160 SCSI support.
Patch136: linux-2.2.18-qlc.patch.bz2

# 802.1d Ethernet Bridging
Patch137: bridge-0.0.9-against-2.2.19pre16.patch.bz2
Patch138: bridge-ipchains-against-0.0.9-against-2.2.19pre16.patch
Patch139: linux-2.2.19-bridge-freeswan.patch

# Patch for vlan patch.
Patch140: linux-2.2.19-vlan-1.0.3-Makefile.patch

# Add UDF file system support: http://linux-udf.sourceforge.net/
Patch141: linux-2.2.18-udf-0.9.3.patch.bz2

# Make UDF lfs-aware.
Patch142: linux-2.2.18-udf-lfs.patch

# IRDA update: ftp://irda.sourceforge.net/pub/irda/patches/
Patch143: linux-2.2.18-23-irda1.patch.bz2

# New DRM from XFree.
Patch144: linux-2.2.20pre9-newdrm.patch.bz2

# Maximise the default max loop to 16.
Patch146: linux-2.2.18-max-loop-to-16.patch

# Make the maximum array for scsci defined to 40 for every scsi adapter.
Patch147: linux-2.2.16-extradevs.patch

# Allow to send a SIGTERM to the nfs lockd server.
Patch148: linux-2.2.18-allow-sigterm-for-nfs.patch

# The Linux kernel does only allow for 128 AppleTalk sockets as per some
# old spec that the low port numbers should be reserved. The only well
# known ports that are used in AppleTalk without name binding are up to
# port number 6, the zone information socket. The attached patch changes
# the algorithm to allocate AppleTalk ports from the high maximum port
# number to the lower numbers, changing the reserved to 7 instead of 128.
# This allows the use of more sockets if really needed while still not
# using the low port numbers until 128 ports have been allocated.
Patch149: linux-2.2.18-atalkports.patch

# Increase multilun to 64 (max).
Patch158: linux-2.2.18-multilun.patch

# Add -a to our custom installkernel.
Patch150: linux-2.2.18-installkernel-a.patch

# Make the symbol with having a _ prefix.
Patch151: linux-2.2.18-ksym-version.patch

# Make proper default options for server.
Patch152: linux-2.2.18-server-tuning.alt.patch

# Supermount support: http://www.geocities.com/alexismikhailov/
# Updated to make it LFS compatible.
Patch154: linux-2.2.18-supermount-0.1.5-lfs.patch.bz2

# Supermount fixes:
# + make some printk go to log;
# + allow eject even if the cdrom is mounted.
Patch155: linux-2.2.18-supermount-0.1.5-fixes.patch

# Fix supermount option parsing.
Patch156: linux-2.2.17-supermount-0.1.5-option.patch

# VIA IDE driver for Linux.
Patch157: linux-2.2.21pre3-via82cxxx.patch

# Net drivers updates: ftp://ftp.scyld.com/pub/network/
# ATP updates: http://www.scyld.com/network/atp.html
# PCI-Scan support from ftp://ftp.scyld.com/pub/network/
# Tulip Update: http://www.scyld.com/network/tulip.html
# Via-Rhine Update: http://www.scyld.com/network/ethercard.html
# RTL8139 Update: http://www.scyld.com/network/rtl8139.html
Patch160: linux-2.2.24-scyld.patch.bz2

# Firewire devices support: http://download.sourceforge.net/linux1394/
Patch170: ieee1394-2.2.18-20001223.patch.bz2

# Fix ohci1394 compilation.
Patch171: linux-2.2.18-ieee1394-ohci_csr_rom.patch

# AGP i850 support.
Patch172: linux-2.2.20pre9-agp_i850.patch

# Historically that was the only way of preventing the .modinfo section
# from being included in modules when they were loaded into the kernel.
Patch173: linux-2.2.18-modinfo-warning-fix.patch

# PCMCIA fixes
Patch174: linux-2.2.20pre10-kcompat-pcmcia.patch
Patch175: linux-2.2.18-pcmcia-Configure.ipl.patch
Patch176: linux-2.2.18-pcmcia-makefile.re.patch

# Guillemot Maxi Radio FM 2 ISA radio card driver.
Patch180: linux-2.2.19-radio-maxifm2.patch

# 3c90x NIC driver.
Patch181: linux-2.2.21-3c90x-1.0.2.patch.bz2

# More RH stuff
Patch190: linux-2.2.18-loop-F1.patch
Patch191: linux-2.2.16-resourcelen.patch
Patch192: linux-2.2.16-scsi-reservation.patch

# More SuSe stuff
Patch200: linux-2.2.19pre16-dc399-127.patch.bz2
Patch201: linux-2.2.10-rl100.patch.bz2
Patch202: linux-2.2.19pre16-acertm5-apm.patch
Patch203: linux-2.2.14-ide-dpt.patch.bz2
Patch204: linux-2.2.16-scsi-mod-unregister.patch
Patch205: linux-2.2.17-buz.patch
Patch206: linux-2.2.16-pci-fix.patch
Patch207: linux-2.2.16-ppSCSI-0.91.patch.bz2
Patch208: linux-2.2.17-enable-multicast-option.patch
Patch209: linux-2.2.16-scsi-sr-smp.patch

# UNICON: ftp://ftp.turbolinux.com.cn/pub/turbolinux/source/unicon/unicon-3.0.3-release.tar.bz2
#Patch211: linux-2.2.18-unicon_1.1.patch.bz2

# Shutup various drivers to log not on console.
Patch212: linux-2.2.22-alt-shutup.patch.bz2

# An ethernet frame diverter for transparent www proxying bridge.
# http://perso.wanadoo.fr/magpie/EtherDivert.html
Patch213: etherdivert-0.5-linux-2.2.18.ipl.patch.bz2

# Update ide-tape.
Patch214: linux-2.2.19-ide-tape-exabyte-eagle-tr4.patch

# Fix include/linux/mc146818rtc.h
Patch215: linux-2.2.19pre16-mc146818rtc.patch

# Fix drivers/scsi/i60uscsi.h
Patch216: linux-2.2.18-i60uscsi.patch

# Fix drivers/isdn/divert/*
Patch217: linux-2.2.21pre3-divert_ioctl.patch

# Shutup i810 to log not on console.
Patch300: linux-2.2.18-i810-shutup.patch

# Added sysctl_msgmax, sysctl_msgmnb, use vmalloc for big messages.
Patch301: linux-2.2.19pre16-bigmessage-with-vmalloc.re.patch

# Modularized framebuffer.
Patch302: linux-2.2.21pre3-alt-fb-modules.patch

# KCOMPAT.
Patch303: linux-2.2.18-kcompat-order.ipl.patch

# I2C compat.
Patch304: i2c-2.6.5-alt-kcompat.patch

# ALT config (building kernel from kernel-source package).
Patch305: linux-2.2.17-altconfig.patch

# Running init verbose.
Patch306: linux-2.2.17-init.ipl.patch

# gzip -9nf.
Patch307: linux-2.2.14-compress_kernel.patch

# BIGMEM fixes.
Patch308: linux-2.2.18-bigmem-fixes.ipl.patch

# NetWare filesystem.
Patch310: linux-2.2.17-nwfs-%nwver.patch

# http://freeshell.org/~djsf/masq-icq/
Patch312: linux-2.2.x-ip_masq_icq-0.56.patch.bz2

# NLS cp1251.
Patch313: linux-2.2.17-nls_cp1251.patch

# International crypto patch.
Patch314: ftp://ftp.kernel.org/pub/linux/kernel/crypto/v2.2/patch-int-%cryptover.bz2
Patch315: linux-2.2.18-crypto_loop_cast.patch
Patch316: linux-2.2.18-crypto_syntax.patch

# Emu10k1 update
Patch317: linux-2.2.17-emu10k1-20010812.patch

# Autofs4 support.
Patch318: linux-2.2.19-autofs4-20001023.patch

# Autofs4 LFS support.
Patch319: linux-2.2.19pre16-autofs4-20001023-lfs.patch

## EXT2 Compression: http://www.netspace.net.au/~reiter/e2compr/
#Patch320: linux-2.2.18-e2compr-%e2cver-patch-2.2.16-ipl.patch.bz2

# E2COMR patch dropped for a while; we keep interface for compatibility.
Patch320: linux-2.2.18-e2compr-interface.patch

# BTTV
Patch321: bttv-0.7.91-buildpatch.patch
Patch322: bttv-0.7.62-kcompat.patch
Patch323: linux-2.2.20-bttv-0.7.86-alt.patch

# More LFS fixes.
Patch324: linux-2.2.19pre16-lfs-filldir.re.patch
Patch325: linux-2.2.18-lfs-fcntl.ipl.patch

# 2.4 cmdline backport.
Patch326: linux-2.2.18-cmdline.patch

# Driver for Granch SBNI12 Leased line modems.
#Patch327: linux-2.2.17-sbni.patch

# Alsa scripts fix.
Patch328: linux-2.2.21pre3-alsa_utils.patch

# IPv4 "Stealth" patch,
# http://www.energymech.net/madcamel/fm/stealth-2.2.18.diff
Patch329: linux-2.2.18-stealth.patch

# Correct size for new ALT Linux logo.
Patch330: linux-2.2.19-video-fbcon.patch

# Prevent from also tracing syscalls the kernel itself makes, which confuses strace.
Patch331: http://www.liacs.nl/~wichert/strace/linux-2.2.20-no-internal-syscall.patch

Patch332: linux-2.2.20pre10-kcompat-isdn.patch

# idescsi= option for ide-scsi driver.
Patch333: linux-2.2.21pre3-alt-idescsi-units.patch

# linux/cdrom.h 2.4.x compatibility.
Patch334: linux-cdrom_generic_command.patch

# linux/input.h 2.4.x compatibility.
Patch335: linux-2.2.21-compat-input.patch

# fs/dcache.c:switch_names() "anti-cannibalization".
Patch336: linux-2.2.25-alt-dcache-switch_names.patch

# Disallow mmap(2) with PROT_EXEC when filesystem is mounted with MNT_NOEXEC.
Patch337: linux-2.2.25-alt-mmap-noexec.patch

# RSBAC patches
Patch400: linux-2.2.20-v1.1.2-rsbac.patch.bz2
%if %rsbacbugfixver
Patch401: rsbac-bugfix-v%rsbacver-%rsbacbugfixver.diff
%endif
Patch402: rsbac-log.patch

####################
### DESCRIPTIONS ###
####################

### KERNELS and MODULES ###
BuildPreReq: /usr/bin/subst

# Automatically added by buildreq on Thu Sep 06 2001
BuildRequires: compat-cpp compat-gcc dev86 man man-pages modutils XFree86-devel XFree86-utils

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

#
# kernel-up: UniProcessor kernel, without Openwall security
#
%package up
Summary: The Linux kernel - core of the GNU/Linux operating system
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel-fb = %kversion, kernel-up = %kversion
Obsoletes: kernel-modules, kernel-sparc, alsa-driver, alsa-dev, kernel-ibcs, kernel-fb, kernel-up, kernel
PreReq: %kernel_prereq

%description up
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

#
# kernel-up-secure: UniProcessor kernel, with Openwall security
#
%package up-secure
Summary: The Linux kernel - core of the GNU/Linux operating system
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel-fb = %kversion, kernel-secure = %kversion, kernel-up-secure = %kversion
Obsoletes: kernel-modules, kernel-sparc, alsa-driver, alsa-dev, kernel-ibcs, kernel-fb, kernel-up-secure, kernel-secure
PreReq: %kernel_prereq

%description up-secure
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

The Openwall patch adds a few security features to the kernel
which, while not a complete method of protection, will stop most of
the 'cookbook' buffer overflow exploits cold. It also adds the option
of restricting the use of symlinks in +t (temp) directories which
fixes most tmp-race exploits as well. It can also add a little bit
more privacy to the system by restricting access to parts of /proc to
root so that users may not see who else is logged on or what they are
doing.

#
# kernel-up-rsbac: UniProcessor kernel, with Openwall security and RSBAC support
#
%package up-rsbac
Summary: The Linux kernel - core of the GNU/Linux operating system
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel-fb = %kversion, kernel-rsbac = %kversion, kernel-up-rsbac = %kversion
Obsoletes: kernel-modules, kernel-sparc, alsa-driver, alsa-dev, kernel-ibcs, kernel-fb, kernel-up-rsbac, kernel-rsbac
PreReq: %kernel_prereq

%description up-rsbac
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

The Openwall patch adds a few security features to the kernel
which, while not a complete method of protection, will stop most of
the 'cookbook' buffer overflow exploits cold. It also adds the option
of restricting the use of symlinks in +t (temp) directories which
fixes most tmp-race exploits as well. It can also add a little bit
more privacy to the system by restricting access to parts of /proc to
root so that users may not see who else is logged on or what they are
doing.

RSBAC is a flexible, powerful and fast open source access control framework
for current Linux kernels, which has been in stable production use for over
a year (since version 1.0.9a).

The RSBAC framework is based on the Generalized Framework for Access Control
(GFAC) by Abrams and LaPadula. All security relevant system calls are
extended by security enforcement code. This code calls the central decision
component, which in turn calls all active decision modules and generates a
combined decision. This decision is then enforced by the system call
extensions.

#
# kernel-smp: Symmetric MultiProcessing kernel, without Openwall security
#
%package smp
Summary: The Linux kernel - core of the GNU/Linux operating system
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel-smp-fb = %kversion, kernel-smp = %kversion
Obsoletes: kernel-smp-fb, kernel-smp
PreReq: %kernel_prereq

%description smp
This package includes a SMP version of the Linux %kversion kernel. It is
required only on machines with two or more CPUs, although it should work
fine on single-CPU boxes.

#
# kernel-smp-secure: Symmetric MultiProcessing kernel, with Openwall security
#
%package smp-secure
Summary: The Linux kernel - core of the GNU/Linux operating system
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel-smp-fb = %kversion, kernel-secure = %kversion, kernel-smp-secure = %kversion
Obsoletes: kernel-smp-fb, kernel-smp-secure, kernel-secure
PreReq: %kernel_prereq

%description smp-secure
This package includes a SMP version of the Linux %kversion kernel. It is
required only on machines with two or more CPUs, although it should work
fine on single-CPU boxes.

The Openwall patch adds a few security features to the kernel
which, while not a complete method of protection, will stop most of
the 'cookbook' buffer overflow exploits cold. It also adds the option
of restricting the use of symlinks in +t (temp) directories which
fixes most tmp-race exploits as well. It can also add a little bit
more privacy to the system by restricting access to parts of /proc to
root so that users may not see who else is logged on or what they are
doing.

#
# kernel-smp-rsbac: Symmetric MultiProcessing kernel, with Openwall security and RSBAC support
#
%package smp-rsbac
Summary: The Linux kernel - core of the GNU/Linux operating system
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel-smp-fb = %kversion, kernel-rsbac = %kversion, kernel-smp-rsbac = %kversion
Obsoletes: kernel-smp-fb, kernel-smp-rsbac, kernel-rsbac
PreReq: %kernel_prereq

%description smp-rsbac
This package includes a SMP version of the Linux %kversion kernel. It is
required only on machines with two or more CPUs, although it should work
fine on single-CPU boxes.

The Openwall patch adds a few security features to the kernel
which, while not a complete method of protection, will stop most of
the 'cookbook' buffer overflow exploits cold. It also adds the option
of restricting the use of symlinks in +t (temp) directories which
fixes most tmp-race exploits as well. It can also add a little bit
more privacy to the system by restricting access to parts of /proc to
root so that users may not see who else is logged on or what they are
doing.

RSBAC is a flexible, powerful and fast open source access control framework
for current Linux kernels, which has been in stable production use for over
a year (since version 1.0.9a).

The RSBAC framework is based on the Generalized Framework for Access Control
(GFAC) by Abrams and LaPadula. All security relevant system calls are
extended by security enforcement code. This code calls the central decision
component, which in turn calls all active decision modules and generates a
combined decision. This decision is then enforced by the system call
extensions.

#
# kernel-boot: kernel for installation
#
%package boot
Summary: The Linux kernel - core of the GNU/Linux operating system
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel-boot = %kversion
Obsoletes: kernel-boot
PreReq: %kernel_prereq

%description boot
This package includes an installation version of the Linux %kversion kernel.

#
# kernel, customized by user.
#
%if_with CUSTOM
%package %CUSTOM
Summary: The Linux kernel - core of the GNU/Linux operating system
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel-%CUSTOM = %kversion
Obsoletes: kernel-%CUSTOM
PreReq: %kernel_prereq

%description %CUSTOM
This package includes a custom version of the Linux %kversion kernel
designed for %CUSTOM box.
%endif #CUSTOM

%package -n alsa22-up
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel-up = %KVERREL
Provides: alsa = %{kversion}_%alsaver, alsa-up = %{kversion}_%alsaver
Obsoletes: alsa, alsa-up, alsa-driver

%description -n alsa22-up
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for default UP kernel.

%package -n alsa22-up-secure
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel-up-secure = %KVERREL
Provides: alsa = %{kversion}_%alsaver, alsa-secure = %{kversion}_%alsaver, alsa-up-secure = %{kversion}_%alsaver
Obsoletes: alsa, alsa-secure, alsa-up-secure, alsa-driver

%description -n alsa22-up-secure
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for default UP secure kernel.

%package -n alsa22-up-rsbac
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel-up-rsbac = %KVERREL
Provides: alsa = %{kversion}_%alsaver, alsa-rsbac = %{kversion}_%alsaver, alsa-up-rsbac = %{kversion}_%alsaver
Obsoletes: alsa, alsa-rsbac, alsa-up-rsbac, alsa-driver

%description -n alsa22-up-rsbac
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for default UP rsbac kernel.

%package -n alsa22-smp
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel-smp = %KVERREL
Provides: alsa-smp = %{kversion}_%alsaver
Obsoletes: alsa-smp, alsa-driver

%description -n alsa22-smp
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for default SMP kernel.

%package -n alsa22-smp-secure
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel-smp-secure = %KVERREL
Provides: alsa-secure = %{kversion}_%alsaver, alsa-smp-secure = %{kversion}_%alsaver
Obsoletes: alsa-secure, alsa-smp-secure, alsa-driver

%description -n alsa22-smp-secure
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for default SMP secure kernel.

%package -n alsa22-smp-rsbac
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel-smp-rsbac = %KVERREL
Provides: alsa-rsbac = %{kversion}_%alsaver, alsa-smp-rsbac = %{kversion}_%alsaver
Obsoletes: alsa-rsbac, alsa-smp-rsbac, alsa-driver

%description -n alsa22-smp-rsbac
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for default SMP rsbac kernel.

%if_with CUSTOM
%package -n alsa22-%CUSTOM
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel-%CUSTOM = %KVERREL
Provides: alsa-%CUSTOM = %{kversion}_%alsaver
Obsoletes: alsa-%CUSTOM, alsa-driver

%description -n alsa22-%CUSTOM
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for %CUSTOM kernel.
%endif #CUSTOM

### SOURCES, HEADERS, DOCS ###

%package headers
Summary: Header files for the Linux kernel
Group: Development/Kernel
PreReq: /usr/sbin/update-alternatives
Requires: kernel-headers-common, initscripts >= 5.49-ipl10mdk
Provides: kernel-headers = %kversion
Obsoletes: kernel-headers
Prefix: %prefix

%description headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for building
most standard programs.  The header files are also needed for rebuilding
the kernel.

%package source
Summary: The source code for the Linux kernel
Group: Development/Kernel
PreReq: kernel22-headers = %KVERREL, /usr/sbin/update-alternatives
Requires: glibc-devel, ncurses-devel, make, compat-gcc, dev86
Provides: kernel-source = %kversion
Obsoletes: kernel-source
AutoReq: no
Prefix: %prefix

%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned to
your particular hardware, if you are so inclined (and you know what you are
doing).

%package doc
Summary: Various documentation bits found in the kernel source
Group: Development/Kernel
Provides: kernel-doc = %kversion
Obsoletes: kernel-doc < 2.4.21
Prefix: %prefix

%description doc
This package contains documentation files form the kernel source. Various
bits of information about the Linux kernel and the device drivers shipped
with it are documented in these files. You also might want install this
package if you need a reference to the options that can be passed to Linux
kernel modules at load time.

%package -n alsa22-source
Summary: The Advanced Linux Sound Architecture (ALSA) source
Group: Development/Kernel
Version: %{kversion}_%alsaver
Requires: kernel-source = %KVERREL, glibc-devel, ncurses-devel, make, compat-gcc, dev86
Provides: alsa-source = %{kversion}_%alsaver
Obsoletes: alsa-source
Prefix: %prefix

%description -n alsa22-source
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package is the source of alsa use it to fit your alsa modules to the kernel.

############
### PREP ###
############

%prep
### SOURCE ###

%setup -q -n linux -a1 -a2 -a3 -a5 -a6 -a7 -a8 -a9 -a10 -a11 -a12 -a13 -a14
# NetWare filesystem.
%setup -q -n linux/fs/nwfs -DTc -a15
%setup -q -n linux -DT
rm -f fs/nwfs/makefile

# For patches.
# PCMCIA
ln -nsf pcmcia-cs-%pcmciaver pcmcia
# ALSA
ln -nsf alsa-driver-%alsaver alsa
# BTTV
ln -nsf bttv-%bttver bttv
# I2C
ln -nsf i2c-%lmver i2c
# FreeSWAN
ln -snf freeswan-%ipsecver freeswan
ln -snf ../freeswan-%ipsecver/klips/net/ipsec net/
ln -snf ../../../lib net/ipsec/libfreeswan
ln -snf ../../../zlib net/ipsec/
ln -snf ../../../libdes net/ipsec/
ln -snf Makefile.kernel net/ipsec/libfreeswan/Makefile
fgrep -lZ 'include "../' freeswan/lib/*.c |
	xargs -r0 subst 's,include "\.\./,include "../klips/net/ipsec/,g'

rm -rf pcmcia/{cardmgr,flash,debug-tools,man,etc,doc,PCMCIA-HOWTO}
rm -rf freeswan/{doc,pluto,utils}

# Bring in the MandrakeKernel Module Version Tag program
install -p -m644 %SOURCE23 .

ln -snf CONFIG.i386 ibcs/CONFIG

chmod u+x scripts/kwhich

###
### PATCHES
###

# Kernel version updates and -ac patches.
%{?prever:%patch1 -p1}

# Fix for 2.2.20-pre9.
%patch2 -p1

# Fix for 2.2.21-pre4.
%patch3 -p1

# Fix for 2.2.24-pre1.
%patch4 -p1

# Patches by Andrea Arcangeli <andrea@suse.de>:
for f in linux-kernel-people-andrea-kernels-v2.2-%andreaver/[[:digit:]][[:digit:]]_*; do
	echo "Patch ${f##*/}"
	patch -p1 -s <"$f"
done

# Define few types and syscalls (for better kernel 2.4 compatibility).
%patch11 -p1
%patch12 -p1

# Apply patch for Openwall patch (i.e. update patch to current kernel, if required).
%patch21 -p0

# Openwall security patch.
echo 'Openwall patch:'
patch -p1 -s <linux-%owver/linux-%owver.diff
mkdir -p Documentation/secure
install -p -m644 linux-%owver/[A-Z]* Documentation/secure

### Vendor patches

# ReiserFS
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1

# IPSEC
%patch105 -p1
%patch106 -p1

# IDE
%patch110 -p1

# AACRAID
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1
%patch115 -p1
%patch116 -p1
%patch117 -p1

# IBCS
%patch120 -p1
%patch121 -p1
%patch122 -p1
%patch123 -p1
%patch124 -p1
%patch125 -p1

# IPVS / VPN
%patch126 -p1
%patch127 -p1

# CIPE
%patch128 -p1

# Add sysrq on serial.
%patch130 -p1

# eepro100*
%patch131 -p1
%patch132 -p1
%patch133 -p1
%patch134 -p1
%patch135 -p1

# Qlogic.
%patch136 -p1

# 802.1d Ethernet Bridging
%patch137 -p1
%patch138 -p1
%patch139 -p1

# Patch for vlan patch.
%patch140 -p1
# Vlan patch itself.
patch -p1 -s <vlan/contrib/vlan_2.2-full.patch

# UDF
%patch141 -p1
%patch142 -p1

# IRDA
%patch143 -p1

# New DRM from XFree.
%patch144 -p1

# Other patches
%patch146 -p1
%patch147 -p1
%patch148 -p1
%patch149 -p1

%patch158 -p1
%patch150 -p1
%patch151 -p1
%patch152 -p1

# Supermount
%patch154 -p1
%patch155 -p1
%patch156 -p1

# VIA IDE driver for Linux.
%patch157 -p1

# Net drivers updates: ftp://ftp.scyld.com/pub/network/
%patch160 -p1

# Firewire
%patch170 -p1
%patch171 -p1

# AGP i850 support.
%patch172 -p1

# Other patches
%patch173 -p1

# PCMCIA fixes
%patch174 -p1
%patch175 -p1
%patch176 -p1

# Guillemot Maxi Radio FM 2 ISA radio card driver.
%patch180 -p1

# 3c90x NIC driver.
%patch181 -p1

# More RH stuff
#%patch190 -p1
%patch191 -p1
%patch192 -p1

# More SuSe stuff
%patch200 -p1
%patch201 -p1
%patch202 -p1
%patch203 -p1
%patch204 -p1
%patch205 -p1
%patch206 -p1
%patch207 -p1
%patch208 -p1
%patch209 -p1

# UNICON
#%patch211 -p1

# Shutup various drivers to log not on console.
%patch212 -p1

# An ethernet frame diverter for transparent www proxying bridge.
%patch213 -p1

# Update ide-tape.
%patch214 -p1

# Fix linux/include/linux/mc146818rtc.h
%patch215 -p1

# Fix linux/drivers/scsi/i60uscsi.h
%patch216 -p1

# Fix linux/drivers/isdn/divert/*
%patch217 -p1

# Shutup i810 to log not on console.
%patch300 -p1

# Added sysctl_msgmax, sysctl_msgmnb, use vmalloc for big messages.
%patch301 -p1

# Modularized framebuffer.
%patch302 -p1

# KCOMPAT.
%patch303 -p1

# I2C compat.
%patch304 -p0

# IPL config (building kernel from kernel-source package).
%patch305 -p1

# Running init verbose.
%patch306 -p1

# gzip -9nf.
%patch307 -p1

# BIGMEM fixes.
%patch308 -p1

# NetWare filesystem.
%patch310 -p1

# http://freeshell.org/~djsf/masq-icq/
%patch312 -p1

# NLS cp1251.
%patch313 -p1

# International crypto patch.
%patch314 -p1
%patch315 -p1
%patch316 -p1

# Emu10k1 update.
%patch317 -p1
find emu10k1 -type f -print0 |xargs -r0 %__grep -FlZ '<emu_wrapper.h>' |
	xargs -r0 subst 's/<\(emu_wrapper\.h\)>/"\1"/'
find emu10k1 -type f -print0 |xargs -r0 %__grep -FlZ 'pci_compat_' |
	xargs -r0 subst 's/\(^\|[^_]\)\(pci_compat_\)/\1emu_\2/g'
find emu10k1 -type f -print0 |xargs -r0 %__grep -FlZ 'ac97_probe_codec' |
	xargs -r0 subst 's/ac97_probe_codec/ac97_probe_codec_emu/g'
mv emu10k1/ac97_codec.c emu10k1/ac97_codec_emu.c

# Autofs4 support.
%patch318 -p1

# Autofs4 LFS support.
%patch319 -p1

# E2COMPR
%patch320 -p1

# LM-Sensors.
pushd i2c-%lmver
./mkpatch/mkpatch.pl . .. >.patch
patch <.patch -d .. -p1 -E -s
popd
pushd lm_sensors-%lmver
subst '
	s/#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,3,1))/#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,2,18))/;
	s/#if LINUX_VERSION_CODE < KERNEL_VERSION(2,3,13)/#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,2,18))/' \
	kernel/chips/*.c
./mkpatch/mkpatch.pl . .. >.patch
patch <.patch -d .. -p1 -E -s
popd

# BTTV
cat bttv/.bp.bt{tv*,audio} |sed -e 's|media/video|char|g' |grep -v '^$' |LC_COLLATE=C sort +2 >bttv/.buildpatch
%patch321 -p1
%patch322 -p1
pushd bttv-%bttver
./buildpatch . ..  >.patch
patch <.patch -d .. -p1 -E -s
for f in `find driver -type f -maxdepth 1 \( -name \*.h -o -name \*.c \)`; do
	if [ ! -e "../drivers/char/${f##*/}" ]; then
		cp -vp "$f" ../drivers/char
	fi
done
popd
%patch323 -p1

install -p -m644 emu10k1{,/2.2}/*.{h,c} drivers/sound/emu10k1

# More lfs fixes.
%patch324 -p1
%patch325 -p1

# 2.4 cmdline backport.
%patch326 -p1

# Driver for Granch SBNI12 Leased line modems.
install -p -m644 sbni12/sbni.{c,h} drivers/net
patch -p1 -s <sbni12/sbni500-2.2.x-patch

# Alsasound script fix.
%patch328 -p1

# IPv4 "Stealth" patch.
%patch329 -p1

# Install ALT Linux logo.
bzcat %SOURCE25 >include/linux/linux_logo.h
%patch330 -p1

# Prevent from also tracing syscalls the kernel itself makes, which confuses strace.
%patch331 -p1

%patch332 -p1

# idescsi= option for ide-scsi driver.
%patch333 -p1

# linux/cdrom.h 2.4.x compatibility.
%patch334 -p1

# linux/input.h 2.4.x compatibility.
%patch335 -p1

# fs/dcache.c:switch_names() "anti-cannibalization".
%patch336 -p1

# Disallow mmap(2) with PROT_EXEC when filesystem is mounted with MNT_NOEXEC.
%patch337 -p1

# RSBAC patches
%patch400 -p1
%if %rsbacbugfixver
%patch401 -p1
%endif
%patch402 -p1

subst "s/-m[34]86//" arch/i386/Makefile

# Get rid of unwanted files.
find -type f \( -name '*~' -o -name '*.orig' -o -name .cvsignore \) -print0 |
	xargs -r0 rm -f --

# Fix permissions.
chmod -R a+rX .

###
### build
###

# ldv: This package requires some magic
%buildmulti
# fakeroot go home!
unset LD_PRELOAD ||:

# We won't debug kernel, do we?
%remove_optflags %optflags_debug

# k6 cannot be SMP.
%ifarch k6
%undefine _with_SMP
%undefine _with_SMP_SECURE
%undefine _with_SMP_RSBAC
%endif

# define kernel arch.
%ifarch %ix86
# BuildConflicts: gcc > 2.96
%define optflags_kernel -malign-loops=2 -malign-jumps=2 -malign-functions=2 -mpreferred-stack-boundary=2
%define karch i386
%else
%define optflags_kernel %nil
%ifarch sparc64
%define karch %_target_cpu
%else
%define karch %_arch
%endif
%endif

Suffix=
What=

MakeVars()
{
	Suffix="-$1"
	What="$1 kernel"
}

BuildKernel()
{
	echo "Building config for the $What"

	Config=%_target_cpu$Suffix
	KernelVer=%KVERREL$Suffix

	cp -p $RPM_SOURCE_DIR/kernel-%kversion-$Config.config arch/%karch/defconfig
	rm -f .config
	# make sure SUBLEVEL and EXTRAVERSION say what we want them to say
	subst "s/^SUBLEVEL.*/SUBLEVEL = %sublevel/; s/^EXTRAVERSION.*/EXTRAVERSION = -%release$Suffix/" Makefile
	if [ "$1" = "boot" ]; then
		OPT_FLAGS="%optflags_core %optflags_warnings -march=%karch -Os"
	else
		OPT_FLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel"
	fi
	subst "s/^HOSTCFLAGS.*/HOSTCFLAGS = $OPT_FLAGS -Wstrict-prototypes/" Makefile
	subst "s/^CFLAGS_NSR.*/CFLAGS_NSR := $OPT_FLAGS/" arch/%karch/Makefile

	make mrproper
	make oldconfig

	cmp -s .config $RPM_SOURCE_DIR/kernel-%kversion-$Config.config || \
		cp -vf .config $RPM_SOURCE_DIR/kernel-%kversion-$Config.config

	echo "Building dependencies for the $What"

	make dep
	make include/linux/version.h

	echo "Building the $What"

	%make_build bzImage

	if grep -q '^CONFIG_MODULES=y' .config; then
		echo "Building modules for the $What"
		%make_build modules
		find include/linux/modules -size 0 |while read file; do
			echo >"$file"
		done
	fi

	mkdir -p $RPM_BUILD_ROOT/boot
	install -p -m644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
	install -p -m644 arch/%karch/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer

	mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/{block,cdrom,fs,ipv4,misc,net,scsi,video,pcmcia,usb}
	if grep -q '^CONFIG_MODULES=y' .config; then
		make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer
	fi
	cc -o rhkmvtag rhkmvtag.c init/version.o
	./rhkmvtag >$RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag ||:
	rm -f rhkmvtag
}

if KGCC="$(sh scripts/kwhich kgcc)"; then
	KGCC_PARAM="CC=$KGCC"
else
	KGCC_PARAM=
fi
eval export $KGCC_PARAM

BuildiBCS()
{
	echo "Building iBCS for the $What"

	%make_build -C ibcs/iBCSemul USE_VERSIONS=yes "SMP=$1" \
		"KERNEL=$RPM_BUILD_DIR/linux" \
		ARCH_FLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel" all
	install -p -m644 ibcs/iBCSemul/iBCS \
		$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/misc/iBCS.o
	make -C ibcs clean
}

BuildPCMCIA()
{
	echo "Building PCMCIA for the $What"

	pushd pcmcia
		make clean
		export FORCED_CONF_SRC=2
		./Configure -n --kernel=$RPM_BUILD_DIR/linux \
			--target=$RPM_BUILD_ROOT \
			--moddir=/lib/modules/%KVERREL$Suffix \
			--srctree \
			--notrust \
			--cardbus \
			--nopnp \
			--sysv --srctree --rcdir=%_sysconfdir/rc.d
		%make_build all \
			CFLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel"
		mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/pcmcia
		%make_install install PREFIX=$RPM_BUILD_ROOT
		%__ln_s i82365.o $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/pcmcia/yenta_socket.o
		mkdir -p $RPM_BUILD_ROOT%_usrsrc/linux/pcmcia-cs-%pcmciaver/include/pcmcia
		sed -e "s|$RPM_BUILD_DIR/linux|%_usrsrc/linux|;s|$RPM_BUILD_ROOT||;" \
			<include/pcmcia/config.h \
			>$RPM_BUILD_ROOT%_usrsrc/linux/pcmcia-cs-%pcmciaver/include/pcmcia/config.h
	popd
}

BuildAlsa()
{
	echo "Building ALSA for the $What"

	pushd alsa
		[ -e Makefile.conf ] && make mrproper

		CFLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel" ./configure \
			--with-kernel=$RPM_BUILD_DIR/linux \
			--with-processor=%_target_cpu --with-smp=auto \
			--with-isapnp --with-sequencer=yes --with-oss=yes \
			--with-cards=%ALSA_MODULES \
			--with-moddir=$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		make COPTS="\$(c_opts) $RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -Wstrict-prototypes" all

		mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		install -p -m644 modules/*.o $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		mv -f $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa/isapnp.o \
			$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/misc
	popd
}

SaveHeaders()
{
	echo "Saving headers for the $What"
	mkdir -p $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix
	install -p -m644 include/linux/autoconf.h \
		$RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/autoconf.h
	install -p -m644 include/linux/version.h \
		$RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/version.h
	if [ -e include/linux/modversions.h ]; then
		sed -e "s,linux/modules/,%_libdir/kernel/%KVERREL$Suffix/modules/,g" <include/linux/modversions.h \
			>$RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/modversions.h
	fi
	cp -a include/linux/modules $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/modules
	pushd $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix
		/usr/bin/h2ph -d . *.h
	popd
}

StripModules()
{
	echo "Striping modules for the $What"
	%strip_relocatable -g $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix
%if_with COMPRESS_MODULES
	echo "Compressing modules for the $What"
	find $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix -type f -name \*.o -print0 |
		xargs -r0 gzip -9n
%endif #COMPRESS_MODULES
	echo "Creating module dependencies for the $What"
	/sbin/depmod -aqr -C /dev/null -F $RPM_BUILD_ROOT/boot/System.map-%KVERREL$Suffix -b $RPM_BUILD_ROOT %KVERREL$Suffix
}

BuildUp()
{
	MakeVars up
%if_with UP
	BuildKernel
%if_with IBCS
	BuildiBCS no
%endif
%if_with PCMCIA
	BuildPCMCIA
%endif
%if_with ALSA
	BuildAlsa
%endif

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif #UP
}

BuildUpSecure()
{
	MakeVars up-secure
%if_with UP_SECURE
	BuildKernel
%if_with IBCS
	BuildiBCS no
%endif
%if_with PCMCIA
	BuildPCMCIA
%endif
%if_with ALSA
	BuildAlsa
%endif

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif #UP_SECURE
}

BuildUpRSBAC()
{
	MakeVars up-rsbac
%if_with UP_RSBAC
	BuildKernel
%if_with IBCS
	BuildiBCS no
%endif
%if_with PCMCIA
	BuildPCMCIA
%endif
%if_with ALSA
	BuildAlsa
%endif

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif #UP_RSBAC
}

BuildSmp()
{
	MakeVars smp
%if_with SMP
	BuildKernel
%if_with IBCS
	BuildiBCS yes
%endif
%if_with PCMCIA
	BuildPCMCIA
%endif
%if_with ALSA
	BuildAlsa
%endif

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif #SMP
}

BuildSmpSecure()
{
	MakeVars smp-secure
%if_with SMP_SECURE
	BuildKernel
%if_with IBCS
	BuildiBCS yes
%endif
%if_with PCMCIA
	BuildPCMCIA
%endif
%if_with ALSA
	BuildAlsa
%endif

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif #SMP_SECURE
}

BuildSmpRSBAC()
{
	MakeVars smp-rsbac
%if_with SMP_RSBAC
	BuildKernel
%if_with IBCS
	BuildiBCS yes
%endif
%if_with PCMCIA
	BuildPCMCIA
%endif
%if_with ALSA
	BuildAlsa
%endif

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif #SMP_RSBAC
}

BuildBoot()
{
	MakeVars boot
%if_with BOOT
	BuildKernel
%if_with PCMCIA
	BuildPCMCIA
%endif

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif #BOOT
}

BuildCUSTOM()
{
	MakeVars %CUSTOM
%if_with CUSTOM
	BuildKernel
%if_with IBCS
	BuildiBCS yes
%endif
%if_with PCMCIA
	BuildPCMCIA
%endif
%if_with ALSA
	BuildAlsa
%endif

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif #CUSTOM
}

###
# DO it...
###

mkdir -p $RPM_BUILD_ROOT%_usrsrc/kernel/linux-%KVERREL
ln -snf kernel/linux-%KVERREL $RPM_BUILD_ROOT%_usrsrc/linux

BuildCUSTOM
BuildBoot
BuildSmpRSBAC
BuildSmpSecure
BuildSmp
BuildUpRSBAC
BuildUpSecure
BuildUp

###
### install
###

%install
echo "Building all the rest"

# Install config files.
mkdir -p configs
install -p -m644 $RPM_SOURCE_DIR/kernel-%kversion-*.config configs

# Supermount README.
install -p -m644 %SOURCE21 Documentation

# Install more driver documentation
for f in `find drivers -type f -name README.\* |fgrep -v .old`; do
	install -p -m644 -D "$f" "Documentation/$f"
done

# Install Alsa documentation.
mkdir -p Documentation/sound/alsa
for f in COPYING INSTALL FAQ README doc/SOUNDCARDS WARNING; do
    install -p -m644 "alsa/$f" Documentation/sound/alsa
done

# Install Alsa headers.
mkdir -p $RPM_BUILD_ROOT%_usrsrc/linux/include/linux
for f in asound.h asoundid.h asequencer.h ainstr_simple.h ainstr_gf1.h ainstr_iw.h; do
	install -p -m644 "alsa/include/$f" $RPM_BUILD_ROOT%_usrsrc/linux/include/linux
done

# Install Emu10k1 documentation
mkdir -p Documentation/sound/emu10k1
install -p -m644 emu10k1/docs/* Documentation/sound/emu10k1

# /Includes links.
mkdir -p $RPM_BUILD_ROOT%_includedir
ln -snf ../src/linux/include/linux $RPM_BUILD_ROOT%_includedir/linux

# iBCS stuff
mkdir -p $RPM_BUILD_ROOT%_mandir/man9
install -p -m644 ibcs/Doc/iBCS.9 $RPM_BUILD_ROOT%_mandir/man9

mkdir -p Documentation/ibcs
cp -a ibcs/{README,RELEASE,CREDITS,Doc} Documentation/ibcs

# Copy all sources.
tar cf - . |tar xf - -C $RPM_BUILD_ROOT%_usrsrc/linux
install -p -m644 %SOURCE20 $RPM_BUILD_ROOT%_usrsrc/linux/Documentation

# Comes from bootloader-utils.
ln -snf /sbin/installkernel $RPM_BUILD_ROOT%_usrsrc/linux/arch/%karch/boot/install.sh

ln -snf ../src/linux/include/asm $RPM_BUILD_ROOT%_includedir/asm

# Make sure EXTRAVERSION says what we want it to say (in sources).
subst "s/^EXTRAVERSION.*/EXTRAVERSION = -%release-custom/" $RPM_BUILD_ROOT%_usrsrc/linux/Makefile

# Use the standard i386 config in source.
install -p -m644 %SOURCE100 $RPM_BUILD_ROOT%_usrsrc/linux/.config
install -p -m644 %SOURCE100 $RPM_BUILD_ROOT%_usrsrc/linux/arch/%karch/defconfig

mkdir -p $RPM_BUILD_ROOT%_usrsrc/kernel/drivers

# Clean up the destination.
make clean -C $RPM_BUILD_ROOT%_usrsrc/linux/pcmcia

%if_with ALSA
make mrproper -C $RPM_BUILD_ROOT%_usrsrc/linux/alsa ||:
%endif

[ -d $RPM_BUILD_ROOT%_usrsrc/kernel/drivers/alsa-driver-%alsaver ] ||
	mv $RPM_BUILD_ROOT%_usrsrc/linux/alsa-driver-%alsaver \
		$RPM_BUILD_ROOT%_usrsrc/kernel/drivers

make clean -C $RPM_BUILD_ROOT%_usrsrc/linux/ibcs ||:

make mrproper -C $RPM_BUILD_ROOT%_usrsrc/linux
make oldconfig -C $RPM_BUILD_ROOT%_usrsrc/linux
make symlinks -C $RPM_BUILD_ROOT%_usrsrc/linux
make include/linux/version.h -C $RPM_BUILD_ROOT%_usrsrc/linux

# We don't ship dependencies.
find $RPM_BUILD_ROOT%_usrsrc/linux/ -name '.*depend' -print0 |
	xargs -r0 rm -f --

rm -rf $RPM_BUILD_ROOT%_usrsrc/linux/include/linux/modules

# Universal headers.
for n in autoconf modversions version; do
	echo "#include </var/run/kernel/$n.h>" >"$RPM_BUILD_ROOT%_usrsrc/linux/include/linux/$n.h"
	chmod 644 "$RPM_BUILD_ROOT%_usrsrc/linux/include/linux/$n.h"
done

# Header subpackage.
pushd $RPM_BUILD_ROOT%_usrsrc/kernel/linux-%KVERREL/include
	mkdir -p $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL/include
	real_asm=`realpath asm`
	real_asm="${real_asm##*/}"
	for d in *; do
		if [ "$d" = "asm" -o "$d" = "asm-generic" -o "$d" = "$real_asm" -o -n "${d##asm*}" ]; then
			cp -a "$d" $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL/include
		fi
	done
popd

mkdir -p $RPM_BUILD_ROOT{%_sbindir,%_mandir/man8}

FindKM()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi

	F="km$Suffix.files"

	:>"$F"

	KernelVer=%KVERREL$Suffix

	echo "/boot/vmlinuz-$KernelVer" >>"$F"
	echo "/boot/System.map-$KernelVer" >>"$F"
	echo "%_libdir/kernel/$KernelVer" >>"$F"

	echo "%%dir /lib/modules/$KernelVer" >>"$F"

	find $RPM_BUILD_ROOT/lib/modules/$KernelVer -mindepth 1 -maxdepth 1 \! -type l |
		sed -e "s|$RPM_BUILD_ROOT||g" |
		fgrep -v /lib/modules/$KernelVer/modules. |
		fgrep -v /alsa >>"$F"

	echo "%%ghost /lib/modules/$KernelVer/modules.*" >>"$F"
}

FindAlsa()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi
	F="alsa$Suffix.files"

	: >"$F"
	echo "/lib/modules/%KVERREL$Suffix/alsa" >>"$F"
	echo "%%doc Documentation/sound/alsa/*" >>"$F"
}

%if_with CUSTOM
FindKM %CUSTOM
%endif

%if_with BOOT
FindKM boot
%endif

%if_with UP
FindKM up
%endif

%if_with UP_SECURE
FindKM up-secure
%endif

%if_with UP_RSBAC
FindKM up-rsbac
%endif

%if_with SMP
FindKM smp
%endif

%if_with SMP_SECURE
FindKM smp-secure
%endif

%if_with SMP_RSBAC
FindKM smp-rsbac
%endif

%if_with ALSA
%ifarch %ix86

%if_with CUSTOM
FindAlsa %CUSTOM
%endif

%if_with UP
FindAlsa up
%endif

%if_with UP_SECURE
FindAlsa up-secure
%endif

%if_with UP_RSBAC
FindAlsa up-rsbac
%endif

%if_with SMP
FindAlsa smp
%endif

%if_with SMP_SECURE
FindAlsa smp-secure
%endif

%if_with SMP_RSBAC
FindAlsa smp-rsbac
%endif

%endif #%ix86
%endif #ALSA

###
### scripts
###

# Do this for upgrades...in case the old modules get removed
# we have loopback in the kernel so that mkinitrd will work.

%if_with UP
%pre up
/sbin/modprobe loop &>/dev/null ||:
%preun up
/sbin/modprobe loop &>/dev/null ||:
%post up
ln -snf vmlinuz-%KVERREL-up /boot/vmlinuz-up
ln -snf initrd-%KVERREL-up.img /boot/initrd-up.img
/sbin/installkernel -a -c %KVERREL-up ||:
[ -f /boot/initrd-up.img ] || rm -f /boot/initrd-up.img
%endif

%if_with UP_SECURE
%pre up-secure
/sbin/modprobe loop &>/dev/null ||:
%preun up-secure
/sbin/modprobe loop &>/dev/null ||:
%post up-secure
ln -snf vmlinuz-%KVERREL-up-secure /boot/vmlinuz-up-secure
ln -snf initrd-%KVERREL-up-secure.img /boot/initrd-up-secure.img
/sbin/installkernel -a -c %KVERREL-up-secure ||:
[ -f /boot/initrd-up-secure.img ] || rm -f /boot/initrd-up-secure.img
%endif

%if_with UP_RSBAC
%pre up-rsbac
/sbin/modprobe loop &>/dev/null ||:
%preun up-rsbac
/sbin/modprobe loop &>/dev/null ||:
%post up-rsbac
ln -snf vmlinuz-%KVERREL-up-rsbac /boot/vmlinuz-up-rsbac
ln -snf initrd-%KVERREL-up-rsbac.img /boot/initrd-up-rsbac.img
/sbin/installkernel -a -c %KVERREL-up-rsbac ||:
[ -f /boot/initrd-up-rsbac.img ] || rm -f /boot/initrd-up-rsbac.img
%endif

%if_with SMP
%pre smp
/sbin/modprobe loop &>/dev/null ||:
%preun smp
/sbin/modprobe loop &>/dev/null ||:
%post smp
ln -snf vmlinuz-%KVERREL-smp /boot/vmlinuz-smp
ln -snf initrd-%KVERREL-smp.img /boot/initrd-smp.img
/sbin/installkernel -a -c %KVERREL-smp ||:
[ -f /boot/initrd-smp.img ] || rm -f /boot/initrd-smp.img
%endif

%if_with SMP_SECURE
%pre smp-secure
/sbin/modprobe loop &>/dev/null ||:
%preun smp-secure
/sbin/modprobe loop &>/dev/null ||:
%post smp-secure
ln -snf vmlinuz-%KVERREL-smp-secure /boot/vmlinuz-smp-secure
ln -snf initrd-%KVERREL-smp-secure.img /boot/initrd-smp-secure.img
/sbin/installkernel -a -c %KVERREL-smp-secure ||:
[ -f /boot/initrd-smp-secure.img ] || rm -f /boot/initrd-smp-secure.img
%endif

%if_with SMP_RSBAC
%pre smp-rsbac
/sbin/modprobe loop &>/dev/null ||:
%preun smp-rsbac
/sbin/modprobe loop &>/dev/null ||:
%post smp-rsbac
ln -snf vmlinuz-%KVERREL-smp-rsbac /boot/vmlinuz-smp-rsbac
ln -snf initrd-%KVERREL-smp-rsbac.img /boot/initrd-smp-rsbac.img
/sbin/installkernel -a -c %KVERREL-smp-rsbac ||:
[ -f /boot/initrd-smp-rsbac.img ] || rm -f /boot/initrd-smp-rsbac.img
%endif

%if_with BOOT
%pre boot
/sbin/modprobe loop &>/dev/null ||:
%preun boot
/sbin/modprobe loop &>/dev/null ||:
%endif

%if_with CUSTOM
%pre %CUSTOM
/sbin/modprobe loop &>/dev/null ||:
%preun %CUSTOM
/sbin/modprobe loop &>/dev/null ||:
%post %CUSTOM
/sbin/installkernel -a -c %KVERREL-%CUSTOM ||:
%endif

%if_with HEADERS
%post headers
/usr/sbin/update-alternatives --install %_libdir/kernel/include kernel_include %_libdir/kernel/%KVERREL/include 22

%preun headers
/usr/sbin/update-alternatives --remove kernel_include %_libdir/kernel/%KVERREL/include

%triggerpostun headers -- kernel22-headers < 2.2.19-alt7
/usr/sbin/update-alternatives --auto kernel_include

%triggerpostun headers -- kernel24-headers < 2.4.9-alt5
/usr/sbin/update-alternatives --auto kernel_include
%endif

%if_with SOURCE
%post source
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 22

%preun source
/usr/sbin/update-alternatives --remove usr_src_linux /usr/src/kernel/linux-%KVERREL

%triggerpostun source -- kernel-headers
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 22

%triggerpostun source -- kernel24-headers < 2.4.8
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 22

%triggerpostun source -- kernel-source
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 22

%triggerpostun source -- kernel24-source < 2.4.8
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 22

%triggerpostun source -- kernel22-source < 2.2.19-alt7
/usr/sbin/update-alternatives --auto usr_src_linux

%triggerpostun source -- kernel24-source < 2.4.9-alt5
/usr/sbin/update-alternatives --auto usr_src_linux
%endif

###
### file lists
###

### KERNELS AND MODULES ###

### UP KERNEL
%if_with UP
%files up -f km-up.files
%endif

### UP SECURE KERNEL
%if_with UP_SECURE
%files up-secure -f km-up-secure.files
%endif

### UP RSBAC KERNEL
%if_with UP_RSBAC
%files up-rsbac -f km-up-rsbac.files
%endif

### SMP KERNEL
%if_with SMP
%files smp -f km-smp.files
%endif

### SMP SECURE KERNEL
%if_with SMP_SECURE
%files smp-secure -f km-smp-secure.files
%endif

### SMP RSBAC KERNEL
%if_with SMP_RSBAC
%files smp-rsbac -f km-smp-rsbac.files
%endif

### %CUSTOM KERNEL
%if_with CUSTOM
%files %CUSTOM -f km-%CUSTOM.files
%endif

### BOOT KERNEL
%if_with BOOT
%files boot -f km-boot.files
%endif

### ALSA MODULES for kernels
%if_with ALSA
%ifarch %ix86

%if_with UP
%files -n alsa22-up -f alsa-up.files
%endif

%if_with UP_SECURE
%files -n alsa22-up-secure -f alsa-up-secure.files
%endif

%if_with UP_RSBAC
%files -n alsa22-up-rsbac -f alsa-up-rsbac.files
%endif

%if_with SMP
%files -n alsa22-smp -f alsa-smp.files
%endif

%if_with SMP_SECURE
%files -n alsa22-smp-secure -f alsa-smp-secure.files
%endif

%if_with SMP_RSBAC
%files -n alsa22-smp-rsbac -f alsa-smp-rsbac.files
%endif

%if_with CUSTOM
%files -n alsa22-%CUSTOM -f alsa-%CUSTOM.files
%endif

%endif #%ix86
%endif #ALSA

### SOURCE, HEADERS AND DOCS ###

### KERNEL HEADERS
%if_with HEADERS
%files headers
%_libdir/kernel/%KVERREL
%endif #HEADERS

### KERNEL SOURCE
%if_with SOURCE
%files source
%dir %_usrsrc/kernel/linux-%KVERREL
%_usrsrc/kernel/linux-%KVERREL/COPYING
%_usrsrc/kernel/linux-%KVERREL/CREDITS
%_usrsrc/kernel/linux-%KVERREL/Documentation
%_usrsrc/kernel/linux-%KVERREL/MAINTAINERS
%_usrsrc/kernel/linux-%KVERREL/Makefile
%_usrsrc/kernel/linux-%KVERREL/README
%_usrsrc/kernel/linux-%KVERREL/REPORTING-BUGS
%_usrsrc/kernel/linux-%KVERREL/Rules.make
%_usrsrc/kernel/linux-%KVERREL/rhkmvtag.c
%_usrsrc/kernel/linux-%KVERREL/configs
%_usrsrc/kernel/linux-%KVERREL/crypto
%_usrsrc/kernel/linux-%KVERREL/drivers
%_usrsrc/kernel/linux-%KVERREL/fs
%_usrsrc/kernel/linux-%KVERREL/include
%_usrsrc/kernel/linux-%KVERREL/init
%_usrsrc/kernel/linux-%KVERREL/ipc
%_usrsrc/kernel/linux-%KVERREL/kernel
%_usrsrc/kernel/linux-%KVERREL/lib
%_usrsrc/kernel/linux-%KVERREL/mm
%_usrsrc/kernel/linux-%KVERREL/modules
%_usrsrc/kernel/linux-%KVERREL/net
%_usrsrc/kernel/linux-%KVERREL/rsbac
%_usrsrc/kernel/linux-%KVERREL/scripts
%_usrsrc/kernel/linux-%KVERREL/security
%dir %_usrsrc/kernel/linux-%KVERREL/arch
%_usrsrc/kernel/linux-%KVERREL/arch/%karch
%_usrsrc/kernel/linux-%KVERREL/freeswan*
%if_with IBCS
%_usrsrc/kernel/linux-%KVERREL/ibcs
%endif
%if_with PCMCIA
%_usrsrc/kernel/linux-%KVERREL/pcmcia*
%endif

%if_with ALSA
### ALSA DRIVER SOURCE
%files -n alsa22-source
%_usrsrc/kernel/drivers/alsa-driver-%alsaver
%endif #ALSA
%endif #SOURCE

### KERNEL DOCS
%if_with DOCS
%files doc
%ifarch %ix86
%if_with IBCS
%_mandir/man9/*
%endif #IBCS
%endif #%ix86
%doc Documentation/*
%endif #DOCS

%changelog
* Sat Feb 21 2004 Dmitry V. Levin <ldv@altlinux.org> 2.2.25-alt2.M22
- Updated to linux-2.2.25-ow2 (CAN-2004-0077).
- Disallow mmap(2) with PROT_EXEC when filesystem
  is mounted with MNT_NOEXEC (backported from 2.6).
- kernel22-doc: updated dependencies (#2691).

* Mon Apr 28 2003 Dmitry V. Levin <ldv@altlinux.org> 2.2.25-alt1
- Updated to kernel 2.2.25 (== 2.2.24 + kmod ptrace fix).
- d_move(): do some efforts to preserve target dentry name.

* Thu Mar 13 2003 Dmitry V. Levin <ldv@altlinux.org> 2.2.24-alt1
- Updated:
  + kernel 2.2.24 release.
  + scyld patch (due to the ethernet padding fixes).
- Fixed kmod ptrace bug.

* Tue Dec 17 2002 Dmitry V. Levin <ldv@altlinux.org> 2.2.23-alt2
- Updated to kernel 2.2.24 rc1.

* Sat Nov 30 2002 Dmitry V. Levin <ldv@altlinux.org> 2.2.23-alt1
- Updated:
  + kernel 2.2.23 release.
  + Openwall security patch version 2.2.22-ow2;
  + FreeS/WAN version 1.99.

* Mon Sep 16 2002 Dmitry V. Levin <ldv@altlinux.org> 2.2.22-alt1
- Updated:
  + kernel 2.2.22 release.
- Use subst instead of perl in build scripts.

* Mon Sep 09 2002 Dmitry V. Levin <ldv@altlinux.org> 2.2.22-alt0.1.rc2
- Updated:
  + kernel 2.2.22 rc2;
  + Openwall security patch version 2.2.21-ow2;
  + FreeS/WAN version 1.98b;
  + PCMCIA Card Services version 3.2.1;
  + Lm_sensors & I2C version 2.6.4.
- Removed menu for -source subpackage.

* Mon May 27 2002 Dmitry V. Levin <ldv@altlinux.org> 2.2.21-alt8
- Updated:
  + kernel 2.2.21 release (== rc4);
  + Openwall security patch version 2.2.21-ow1;
  + FreeS/WAN version 1.97;
  + BTTV version 0.7.92.

* Thu May 16 2002 Dmitry V. Levin <ldv@altlinux.org> 2.2.21-alt7.r4
- Updated:
  + kernel 2.2.21 rc4.

* Thu Apr 11 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.2.21-alt7.r3
- Fixed:
  + shrink_dcache_memory breakage in -pre4.

* Tue Apr 09 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.2.21-alt6.r3
- Updated:
  + 3c90x NIC driver version 1.0.2.
- Added:
  + yenta_socket.o compatibility symlink;
  + specfile logic to build with/without ALSA,PCMCIA,IBCS.

* Tue Apr 02 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.2.21-alt5.r3
- Updated:
  + kernel 2.2.21 rc3;
  + FreeS/WAN version 1.96;
  + Lm_sensors & I2C version 2.6.3;
  + BTTV version 0.7.91.
- Added:
  + linux/input.h 2.4.x compatibility.
  + New --with/--without specfile logic for conditional build.

* Fri Mar 15 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.2.21-alt4.r2
- Updated:
  + kernel 2.2.21 rc2.

* Wed Mar 13 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.2.21-alt4.r1
- Updated:
  + kernel 2.2.21 rc1.
- Added:
  + linux/cdrom.h 2.4.x compatibility.

* Mon Mar 11 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.2.21-alt3.p4
- Updated:
  + kernel 2.2.21 pre4.
- Fixed:
  + bluesmoke breakage in -pre4.

* Wed Mar 06 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.2.21-alt2.p3
- Fixed:
  + fat driver breakage in -pre3.

* Mon Mar 04 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.2.21-alt1.p3
- Fixed:
  + kernel-source subpackage (#0000411).
- Updated:
  + kernel 2.2.21 pre3;
  + Openwall security patch version 2.2.20-ow2;
  + Patches by Andrea Arcangeli version 2.2.21pre2aa2;
  + FreeS/WAN version 1.95;
  + PCMCIA Card Services version 3.1.33;
  + ALSA driver version 0.5.12a;
  + BTTV version 0.7.90.

* Thu Nov 22 2001 Dmitry V. Levin <ldv@alt-linux.org> 2.2.20-alt2
- Updated:
  + Lm_sensors & I2C version 2.6.2;
  + BTTV version 0.7.86
- Added:
  + RSBAC 1.1.2
  + New packages: up-rsbac, smp-rsbac (with Openwall and RSBAC enabled).

* Fri Nov 09 2001 Dmitry V. Levin <ldv@alt-linux.org> 2.2.20-alt1
- Fixed:
  + Syncookies vulnurability.
- Updated:
  + kernel 2.2.20 release;
  + Openwall security patch version 2.2.20-ow1;
  + patches by Andrea Arcangeli version 2.2.20aa1;
  + ALSA driver version 0.5.12;
  + BTTV version 0.7.85;
  + Emu10k1 snapshot 20011111.

* Fri Oct 19 2001 Dmitry V. Levin <ldv@alt-linux.org> 2.2.19-alt7
- Fixed:
  + local DoS via deep symlinks;
  + local root compromise by ptrace;
  + sematic of update-alternatives calls (finally).
- Updated:
  + Openwall security patch version 2.2.19-ow3.
  + Emu10k1 snapshot 20011019;
- Added:
  + definitions of several types and syscalls (for better 2.4 compatibility).

* Mon Sep 17 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.2.19-alt6
- Updated:
  + kernel 2.2.20pre10;
  + patches by Andrea Arcangeli version 2.2.20pre10aa1;
  + PCMCIA Card Services version 3.1.29;
  + BTTV version 0.7.79.

* Wed Sep 05 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.2.19-alt5
- Fixed:
  + sematic of update-alternatives calls (headers, source);
  + server-tuning: fix _SHM_ID_BITS value.
  + syscall_trace: prevent from also tracing syscalls the kernel itself makes, which confuses strace.
- Updated:
  + patches by Andrea Arcangeli version 2.2.20pre9aa2;
  + Lm_sensors & I2C backport version 2.6.1;
  + 802.1Q VLAN implementation for Linux (release 1.4);
  + Emu10k1 snapshot 20010906;
  + PreReqs for kernels (added mkinitrd >= 2.7.1-alt3 just in case).
- Added:
  + creation of module dependencies for all kernels selected for build.

* Tue Aug 14 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.2.19-alt4
- Updated:
  + kernel 2.2.20pre9;
  + patches by Andrea Arcangeli version 2.2.20pre8aa1;
- Added:
  + Documentation for patches by Andrea Arcangeli.
- Changed:
  + kernel22-headers subpackage now lives in %_libdir/kernel/%KVERREL directory;
  + Common part of kernel-headers from various kernel versions now in
    kernel-headers-common package;
  + kernel22-source package now contains include subtree in itself;
  + New target "headers_install" in main Makefile for proper install of kernel
    headers in case of custom kernel build from sources.

* Wed Aug 08 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.2.19-alt3
- Updated:
  + ReiserFS version 3.5.33;
  + FreeS/WAN version 1.91;
  + IDE driver version 05042001;
  + ALSA driver version 0.5.11;
  + PCMCIA Card Services version 3.1.28;
  + Lm_sensors & I2C backport version 2.6.0;
  + BTTV version 0.7.73;
  + Emu10k1 snapshot 20010812;
  + Driver for Granch SBNI12 Leased line modems.
- Added
  + 802.1Q VLAN implementation for Linux (release 1.0.3);
  + Guillemot Maxi Radio FM 2 ISA radio card driver;
  + ALT Linux logo for framebuffer;
  + .ph files in %_libdir/kernel/%KVERREL-*/.
- Changed:
  + Packages now have kernel22/alsa22 prefix;
  + CONFIG_BLK_DEV_IDECD=m;
  + CONFIG_SCSI=m;
  + CONFIG_BLK_DEV_SD=m;
  + CONFIG_BLK_DEV_SR=m;
  + CONFIG_REISERFS_FS=m;
  + CONFIG_ISO9660_FS=m;
  + CONFIG_SMB_NLS_REMOTE="cp866";
  + CONFIG_NLS_DEFAULT="koi8-r".

* Thu Apr 05 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.2.19-alt2
- Fixed VIA IDE PCI calibration code.

* Mon Apr 02 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.2.19-alt1
- Fixed:
  + ptrace/execve race condition.
- Updated:
  + kernel 2.2.19 release;
  + Openwall security patch version 2.2.19-ow1;
  + ReiserFS version 3.5.32;
  + FreeS/WAN version 1.9;
  + IDE driver version 03252001;
  + VIA IDE driver version 4.2;
  + tulip version 0.92;
  + BTTV version 0.7.62;
  + Emu10k1 snapshot 20010401;
  + IPVS version 1.0.6.

* Sat Mar 17 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.2.18-ipl5mdk
- Updated:
  + BTTV version 0.7.59.
- Added:
  + Simlinking for initrd images at %%post stage.

* Sat Mar 10 2001 Dmitry V. Levin <ldv@fandra.org> 2.2.18-ipl4mdk
- Updated:
  + kernel 2.2.19pre16;
  + patches by Andrea Arcangeli;
  + ReiserFS version 3.5.31;
  + PCMCIA Card Services version 3.1.25;
  + rtl8139;
  + 3c90x 1.0.0i;
  + aacraid 1.0.7;
  + AGP (added i850 support);
  + ide-tape.
- Added:
  + Autofs-4 support.
- Changed:
  + Compressed all modules (not by default yet);
  + Default kernel subpackages.

* Mon Feb 12 2001 Dmitry V. Levin <ldv@fandra.org> 2.2.18-ipl3mdk
- Three security holes fixed:
  + ptrace() race condition;
  + error in sysctl() bounds check;
  + PIII mxcsr DOS.
- Updated:
  + Openwall security patch version 2.2.18-ow4;
  + Emu10k1 snapshot 20010201.

* Sat Feb 03 2001 Dmitry V. Levin <ldv@fandra.org> 2.2.18-ipl2mdk
- Fixed:
  + IPC SHM for secure kernels (Solar Designer <solar@openwall.com>);
  + build of iBCS module with versioning;
  + mc146818rtc.h header;
  + route-related config options (enabled);
  + kernel-source for custom-only build (alsa fix);
  + files from kernel-source subpackage, provided by pcmcia-cs and freeswan packages (removed).
- Updated:
  + DRM support from XFree86-4.0.2;
  + IDE driver version 20001221;
  + ALSA driver version 0.5.10b;
  + Emu10k1 snapshot 20010201;
  + PCMCIA Card Services version 3.1.24;
  + Lm_sensors & I2C backport version 2.5.5;
  + BTTV version 0.7.54;
  + Openwall security patch version 2.2.18-ow2;
  + Firewire version 20001223;
  + IPVS version 1.0.3.
- Added:
  + Stealth IP stack patch;
  + 802.1d Ethernet Bridging;
  + ESS Maestro3/Allegro driver.
- Changed:
  + moved kernel-dependent headers from kernel-headers subpackage to kernel subpackages;
  + method of autogenerating links to kernel-dependent headers at boot time.

* Thu Dec 21 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.18-ipl1mdk
- Updated:
  + kernel 2.2.18 final, see
    http://www.linux.org.uk/VERSION/relnotes.2218.html for details;
  + patches from kernel-2.2.18aa2 (Andrea Arcangeli <andrea@suse.de>),
    including core, raid, LFS, LVM updates;
  + IDE driver version 20001209;
  + ALSA driver version 0.5.10;
  + Emu10k1 snapshot 20001221;
  + PCMCIA Card Services version 3.1.23;
  + ReiserFS version 3.5.28;
  + BTTV version 0.7.50;
  + international crypto patch version 2.2.18-3;
  + Openwall security patch version 2.2.18-ow1;
  + net drivers from ftp.scyld.com;
  + firewire version 20001012;
  + NLS cp1251 support (from AEN);
  + ethernet frame diverter version 0.5; userspace utilities in outstanding
    packages (divert-utils and bridgex);
  + e2compr support dropped for a while;
    e2compr interface support kept for compatibility.
- Fixed:
  + supermount (works again).
  + framebuffer modularization: building as modules following card drivers:
    aty128fb, atyfb, matroxfb, mdacon, pm2fb;
    vesafb compiled in kernel, since it cannot be module by definition
    (see file %_usrsrc/linux/Documentation/fb/vesafb.txt for details);
  + error reporting in atyfb and aty128fb - these modules will not load
    if no cards available.
- Added:
  + FreeS/WAN version 1.8 (IPsec implementation); userspace utilities
    in outstanding freeswan-utils package.
- Changed:
  + kernel-pcmcia-cs subpackage obsoleted by outstanding pcmcia-cs package;
  + kernel-utils subpackage obsoleted by outstanding ksymoops package;
  + nwfs-utils subpackage obsoleted by outstanding nwfs-utils package;
  + reiserfs-utils subpackage obsoleted by outstanding reiserfs-utils package.

* Wed Oct 25 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.17-ipl3mdk
- Fixed:
  + VM bugs (from Andrea Arcangeli <andrea@suse.de>);
  + Various fixed from MDK, RH, SuSe.
- Updated:
  + initcall & kcompat from 2.2.18pre;
  + AGP/DRM support (from MDK);
  + USB support from 2.2.18pre;
  + IDE driver version 20000904;
  + ALSA driver version 0.5.9d;
  + Emu10k1 snapshot 20001024;
  + PCMCIA Card Services version 3.1.21;
  + ReiserFS version 3.5.27;
  + lm_sensors & i2c backport version 2.5.4;
  + International crypto patch version 2.2.17-10 (new ciphers);
  + Openwall security patch version 2.2.17-ow1;
  + Various driver updates from MDK, RH, SuSe.
- Added:
  + Large File System (LFS) support
    (requires glibc update for complete support);
  + Logical Volume Manager (LVM) support
    (requires userspace administration tools to use);
  + Support for masquerading of the PPTP Virtual Private Network protocol;
  + Support for limited masquerading of the IPsec ESP network encryption
    and ISAKMP authentication and key-exchange protocols;
  + Support for setup parameters for framebuffer modules.
- Changed:
  + Specfile now supports modular packaging;
  + Normal and framebuffer kernels have been merged, framebuffer
    card support now build as modules.

* Fri Sep 08 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.17-ipl2mdk
- Updated:
  + ReiserFS version 3.5.25.

* Thu Sep 07 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.17-ipl1mdk
- Updated:
  + Kernel 2.2.17 final;
  + ALSA driver version 0.5.9c;
  + Emu10k1 snapshot 20000903;
  + PCMCIA Card Services version 3.1.20;
  + ISA SBNI12-xx driver version "Leticia".
- Fixed:
  + supermount options parsing (by Sviatoslav Sviridov <svd@lintec.minsk.by>).
  + k6 config.

* Mon Aug 28 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.17-ipl0.20mdk
- Merge in MDK changes (Chmouel Boudjnah):
  + Merge/Add all the DRM/i810/3D acceleration from Red Hat and kernel-2.4.
  + Big .config review and rh merge (didn't do this since last year /me say it's a pain).

* Thu Aug 24 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.17-ipl0.19mdk
- Updated:
  + Kernel 2.2.17 pre-patch 20.
- Added:
  + NetWare filesystem support;
  + NWFS utilities.

* Mon Aug 21 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.17-ipl0.18mdk
- Updated:
  + Kernel 2.2.17 pre-patch 19.

* Fri Aug 18 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.17-ipl0.17mdk
- Updated:
  + Kernel 2.2.17 pre-patch 18;
  + ALSA driver version 0.5.9b.

* Wed Aug 16 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.17-ipl0.16mdk
- Updated:
  + Kernel 2.2.17 pre-patch 17;
  + lm_sensors & i2c backport version 2.5.2;
  + ALSA driver version 0.5.9a;
  + IDE driver version 20000722;
  + ReiserFS version 3.5.24;
  + BTTV driver version 0.7.37.

* Thu Aug  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.16mdk
- Fix slab with USB (acox).
- Move isapnp.o to misc/.
- 2.2.17pre15.

* Mon Jul 31 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.15mdk
- Correct BuildPCMCIA.
- Correct bttv with LM_sensors.
- More revert raid with pre14.
- 2.2.17pre14.

* Sun Jul 30 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.14mdk
- Add cp950 support (helped by the author)

* Fri Jul 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.13mdk
- Add unicon support.
- Update (NCR|SYM)53c8 scsci drivers.
- Add DRM support. (helped by flepied).
- Pcmcia 3.1.19.

* Thu Jul 27 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.12mdk
- Add usb serial update from 2.4.
- Add i815 support (nico).
- Fix firewire on ppc.
- Upgrade firewire from cvs.
- Upgrade to 20000707 the ide patches.
- Merge with redhat patches.
- Update of bttv support (titi).

* Wed Jul 19 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.11mdk
- Upgrade firewire patches.
- reiserfs 3.5.23.
- 2.2.17pre13.
- disable CONFIG_WDC_ALI15X3.
- pcmcia as config files.

* Wed Jul 19 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.10mdk
- More macros.
- BM
- remove sblive support since it merge in main kernel.
- 2.2.17pre12.
- 2.2.17 ppc support.
- ppc patches.

* Tue Jul 11 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.9mdk
- Backport i810  from 2.4.x like RH.
- CONFIG_VIA82CXXX_TUNING off.
- Merge with rh patches.
- 2.2.17pre11.

* Thu Jul 06 2000 Francis Galiegue <fg@mandrakesoft.com> 2.2.17-0.8mdk
- Merged sparc patches from u5 (505: way ugly NFS fix, 506: bootlogo fix)
	(please someone find a reason why Patch505 fixes NFS hangs - mail to lkml
	but no reply)
- Some alpha patch fixes (510 not necessary anymore, 511 didn't apply cleanly)
- Updated sparc and alpha config files

* Wed Jul  5 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.7mdk
- Fix pcmcia.

* Tue Jul  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.6mdk
- 2.2.17pre10.
- Compile with -O2 when compiling with gcc2.96.
- Add patch when compiling with gcc2.96.
- Add utf8 support (pablo).

* Fri Jun 30 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.17-ipl0.5mdk
- Updates:
  + lm_sensors-2.5.1;
  + crypto 2.2.16.2;
  + e2compr-0.4.38.
- FHSification.

* Thu Jun 29 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.5mdk
- Add LAPB (fix Cyclades-PC300 module).
- Fix eepro module.

* Wed Jun 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.4mdk
- 2.2.17pre9.

* Wed Jun 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.3mdk
- s|bin86|dev86|;
- Upgrade DAC960 to 2.2.6.

* Tue Jun 27 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.2mdk
- Define NR_FILE to 8192.
- Upgrade isdn from cvs.
- Upgrade irda.
- Add first ieee1394 support (aka: Firewire).
- Merge and add Suse i386 patches.
- Add workaround for acertm5 laptop (add apm=acertm5 to workaround it)
- Make advertising for Reiserfs less bigger.
- Upgrade Solar Designer patches.
- Add/Merge various patches from SuSE for ReiserFS.
- Reiserfs 3.5.22.
- Upgrade udf patch.
- Spec and patches cleanup.

* Mon Jun 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.17-0.1mdk
- Pcmcia-3.1.17.
- Alsa-0.5.8b.
- Upgrade to last emu10k1 from cvs.
- 2.2.17pre7.

* Sat Jun 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.16-10mdk
- Launch pcmcia before the network.
- Upgrade USB backport patchs.

* Thu Jun 22 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.16-9mdk
- Ipvs 0.9.14.
- Uprade aicxx driver to 5.1.31 (correct scsci zip problem).
- Reinsert emu10k1.

* Wed Jun 21 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.16-8mdk
- Remerge with last rh patches.

* Wed Jun 21 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.16-7mdk
- FAT CD fix (from 2.2.17pre?).

* Tue Jun 20 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.16-6mdk
- Upgrade usb backport to last 2.4.0ac22, fix is :
     * Fixed G4 Mac disabled OHCI memory
     * Fixed digi acceleport __NO_VERSION__
     * Fixed PMAC #includes
     * Fixed audio compiletime bug
     * Added APM support
     * Added CPiA 1.0 modules
     * Fixed serial driver __NO_VERSION__

* Sun Jun 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.16-5mdk
- Active USB_DEVICEFS.
- Merge with rh patchs.

* Wed Jun 14 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.16-4mdk
- addd CONFIG_SMD_DISKLABEL.
- Add the kversion to the subpackage to avoid conflicts.

* Mon Jun 12 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.16-3mdk
- Apply 2.2.16-combo from Alan Cox.

* Fri Jun  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.16-2mdk
- Use ide patchs for 2.2.16 from Bartlomiej Zolnierkiewicz.
- Fix pcmcia build.

* Thu Jun 08 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.16-ipl1mdk
- Updates:
  + kernel-2.2.16;
  + alsa-driver-0.5.8a.

* Tue May 30 2000 Dmitry V. Levin <ldv@fandra.org> 2.2.15-ipl11mdk
- Fixes:
  + quota oops fix;
  + bigmem memory statistics fix.
- Updates:
  + IDE driver version 20000509;
  + Reiserfs version 3.5.21;
- Features:
  + International crypto patch;
  + EXT2 filesystem compression support;
  + new I2C drivers;
  + Hardware health monitoring modules;
  + ip_masq_icq module.
- Alsa modules are built for each kernel.
- RE and Fandra adaptions.

* Sun May 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-11mdk
- Remove ibCs package (move devices to dev-package, doc to kernel-doc
  and keep modules in the kernel*).
- Go back to 1.27 version for dmfe on alpha.
- Fix udelay call on alpha for lmc net drivers.

* Sun May 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-10mdk
- Includes USB for alpha (since this sound like working).
- Fix signals with usb and new sigiosock.

* Thu May 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-9mdk
- Don't Requires: bin86 for kernel-source on other arch than ia32.

* Thu May 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-8mdk
- Fix sparc64 compilation.

* Mon May 22 2000 Francis Galiegue <fg@mandrakesoft.com> 2.2.15-8mdk
- header fix for asm-sparc/reg.h
- added comments in spec

* Fri May 19 2000 Franois Pons <fpons@mandrakesoft.com> 2.2.15-7mdk
- Fix sparc and sparc64 compilation.
- Don't prereq rdev for sparc and sparc64 too.
- added patchs 501, 502, 503 for compilation.

* Thu May 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-6mdk
- Don't prereq rdev for alpha.
- Fix bad sources.
- Fix loading initrd with alpha.

* Mon May 15 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-6mdk
- Fix build as users.

* Mon May 15 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-5mdk
- Updates config files for alpha.

* Wed May 10 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-4mdk
- Fix pcmcia again :[

* Tue May  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-3mdk
- Fix pcmcia.
- Correct .config with UDMA66.
- Fix version with reiserfs.

* Sun May  7 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-2mdk
- Upgrade usb backport from 2.3.99-pre7-1.
- Fix Bigmem support.

* Thu May  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-1mdk
- 2.2.15 final.

* Thu May  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.30mdk
- Fix pcmcia.
- Don't compile smp for fb.

* Wed May  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.29mdk
- Fix logofb.
- Fix i810.
- Fix menu.
- Add by default the ide patchs for u66 in kernel.

* Wed Apr 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.28mdk
- Upgrade the usb backport from 2.3.99-pre6.
- Build alsa with --with-oss=y --with-sequencer=y.
- Upgrade aic7xxx driver to 5.1.29.

* Tue Apr 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.27mdk
- Add menu entry for make xconfig and icons.
- Fix xconfig with newagpdist patch.
- linkx install.sh to installkernel from initscripts.
- Add missing prereq.
- Add %defattr.
- better logo from ln.

* Tue Apr 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.26mdk
- Fix alpha compilation.
- Make scsi of alpha as modules.
- 2.2.15-pre20:
		fix an NFS bug in pty code introduced in 2.2.15pre19.

* Sun Apr 23 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.25mdk
- Add alsa drivers to alsa package for all arch.
- Add Readme for supermount.
- supermount-0.1.5.
- ipvs-0.9.11.
- new and powerfull installkernel, can add entry to grub and lilo.
- Use installkernel in %post (and depend Prereq).
- Fix usbdevfs backport (no active by default).

* Thu Apr 20 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.15-0.24mdk
- fix pcmcia modules.

* Wed Apr 19 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.15-0.23mdk
- fsck.reiserfs points to /bin/true.
- new logos.

* Tue Apr 18 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.15-0.22mdk
- added i810 driver from XFree86.

* Sun Apr 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.21mdk
- 2.2.15pre19.
- Alsa-0.5.7.
- pcmcia-3.1.14.
- Don't ask question when using -f with mkreiserfs.
- Apply suse patch for symlinks with reiserfs.

* Thu Apr  6 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.20mdk
- Fix usb-storage backport oops.
- alsa-0.5.7.
- Really apply patch :\.

* Wed Apr  5 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.19mdk
- reAdd patch to don't check conunt on CD_DO_IOTCL.
- reAdd patch to redirect the I/O error of supermount to syslog.

* Sat Apr  1 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.18mdk
- Adjust groups.
- Add reiserfs support.
- Alsa-0.5.6.
- pcmcia-cs-3.1.13.
- 2.2.15pre17.

* Fri Mar 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.17mdk
- Add security patch on ipmasquerading and ftp (bugtraq).
- Compile sparc64 in sparc32 (ask sparc team).
- Add lot of Requires for (alsa|kernel)-source.
- Don't set CONFIG_APM_REAL_MODE_POWER_OFF (break 95% of x86 arch).
- BuildAlsa for smp and fb.
- Don't use CPIA_PP from usb backport but use the official one.
- 2.2.15pre15.

* Mon Mar 13 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.16mdk
- Add UDF patch.

* Sun Mar 12 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.15mdk
- Fix emu10k1 clean-up.
- Don't compile CPIO_PP with usb backport.
- 2.2.15pre14

* Thu Mar  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.14mdk
- Fix typo in Requires :\.

* Thu Mar  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.13mdk
- Alsa package requires modutils >= 2.3.9.
- Alsa Obsoletes alsa-drivers (titi).
- Add usb backport from 2.3 to 2.2 (and even get working).
- Put usb modules in /lib/modules/*/usb (modutils 2.3.9 handle nicely).

* Mon Mar  6 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.12mdk
- Build Emu10k1 like the old and ugly time.

* Sat Mar  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.11mdk
- Fix files conflict when installing with rpm -i multiples kernel.
- 2.2.15pre13
- Fix requires for alsa-source.
- Fix bad macros (rpm bug ?).
- Alsa-0.5.5.
- 2.2.15pre12.

* Thu Feb 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.9mdk
- 2.2.15pre10.
- supermount 0.1.4a.
- Remove bigmem (buggy).
- Move modules to alsa to his own package compile only for kernel
  package and add a alsa-source package.

* Wed Feb 23 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.8mdk
- Config file as %doc of each kind of package.
- Version 2 of openwall patchs.
- Fix Provides lines (Axalon).
- 2.2.15pre9.
- Fix various ksymoops weirdness.
- Revert raid1 stuff from pre? kernel (we use the new Raid style).
- Merge with RedHat patchs (74 patchs mostly backport).
- Pcmcia-3.1.11.
- Alsa-0.5.3.

* Fri Jan 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.6mdk
- Renamed release for the new name scheme.
- 2.2.15pre5.
- Fix initrd for alpha.
- Add modifed logo.h for sparc.

* Wed Jan 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-5mdk
- Fix bad statfs with supermount (author).
- Update of Sblive drivers from CVS.

* Mon Jan 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-4mdk
- Disable supermount for sparc.
- Remove ptmodem drivers.
- Remove modules.dep in %pre.
- Disable UMSDOS.
- 2.2.15pre4.
- Alsa 0.5.1.
- Get finally work the fu*** sparc kernel.

* Tue Jan 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-2mdk
- 2.2.15pre3.

* Sun Jan 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-1mdk
- 2.2.15pre2.
- Remove eepro patch (in 2.2.15pre2).
- Upgrade ide patchs (don't apply it just here for future).
- pcmcia 16-JAN-00.
- fix sparc compilation and config files.

* Wed Jan 12 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.14-16mdk
- Remove module-info
- pcmcia 10-JAN-00.
- Make the rpm friendly-build for sparc(64) and alpha.
- Merge with last rh patches.
- ksysmoops 2.3.3.
- Spec cleanup.
- Last Openwall patches.

* Tue Jan  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.14-15mdk
- 2.2.14 final.

* Mon Jan  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.14-14mdk
- Fix pcmcia permissions (thnks rpmlint).
